# Make synthetic chirp data.
#	Chirp n1=50 n2=50 d1=1 d2=1 p=.5 > out.H
#%
integer n1,n2
from par:	integer n1=50, n2=50
allocate:	real datr(n1,n2)

subroutine doit(n1,n2,datr)
integer i1,i2,n1,n2
real datr(n1,n2)
real o1,o2,d1,d2,p,t,x,tmax,tau
#from par:	real p=.5, d1=1., o1=-d1*n1*.33
from par:	real p=.5, d1=1., o1=0
from par:	real       d2=1., o2=0
call zero( n1*n2, datr)
do i1=1,n1 { t = o1 + d1 * (i1-1)
do i2=1,n2 { x = o2 + d2 * (i2-1)
	tmax = n1*d1*.75
	tau = t - p*x
	call chirp( tau, tmax, datr(i1,i2))
	}}
to history:	integer n1, n2
to history:	real o1,d1,o2,d2
call putch('label1','s','t-axis')
call putch('label2','s','x-axis')
call hclose()
call srite('out', datr, 4*n1*n2)
call exit(0); end

subroutine chirp( tau, taumax, value)
real tau, taumax, omegamax, value, circles
omegamax = 2.*3.1416
if( 0 < tau && tau < taumax )
	value = sin( .5 * omegamax * tau **2 / taumax )
else
	value = 0.
return; end
