! Make synthetic chirp data.
!	Chirp n1=50 n2=50 d1=1 d2=1 p=.5 > out.H
!%
use sep
implicit none

integer 				:: n1,n2, i1, i2
real, dimension (:,:), allocatable	:: data, tau
real, dimension (:), allocatable	:: t
real 					:: o1,o2,d1,d2,p, x,tmax
real, parameter				:: omegamax = 2.*3.1416

call sep_init ()
call from_par ("n1", n1, 50)
call from_par ("n2", n2, 50)
call from_par ("p", p, .5)
call from_par ("d1", d1, 1.) ; call from_par ("o1", o1, 0.)
call from_par ("d2", d2, 1.) ; call from_par ("o2", o2, 0.)
call to_history ("label1","t-axis")
call to_history ("label2","x-axis")
call sep_close()

tmax = n1*d1*.75

allocate (t (n1))
t = (/ (o1 + d1 * (i1-1), i1 = 1, n1) /)

allocate (tau (n1, n2))
do i2=1,n2 
	x = o2 + d2 * (i2-1)
	tau (:,i2) = t  - p*x
end do

allocate (data(n1,n2))
where ( 0 < tau .and. tau < tmax )
	data = 	sin (.5 * omegamax * tau **2 / tmax)
elsewhere
	data = 0.
end where

call sep_write (data)
deallocate (tau, t, data)
call exit(0)
end
