# Butterworth filter --- apply to all traces in a cube
#
# <in.h  Butterworth cutoff=.3  hilo=1. ncoef=4  >out.h
#
#   cutoff=	in Nyquist units, i.e. cutoff=1 for (1,-1,1,-1...)
#   hilo=	{1.,-1.} for {low,high}-pass filter
#   ncoef=	number of coefficients in numerator and denominator.	
#
# BUGS:  High order filters require impossible precision, so
#	safest to test first with:
#
#	Spike n1=200 k1=1| Butterworth par=my_par |Spectra|Graph|Tube
#
# keyword butterworth filter
# JFC
#% end of self doc.
                integer n1, n2,   n3
from history:	integer n1, n2=1, n3=1
allocate: 	real datr(n1), temp(n1+100)

subroutine goodie(n1,n2,n3,datr, temp)
integer i1,n1,i2,n2, i3,n3, ncoef, i
real datr(n1), cutoff, hilo, num(100), den(100), temp(1)
from par:	real	cutoff=.5, hilo=1.
from par:	integer  ncoef=4
call butter( hilo, cutoff, ncoef, num, den)
call hclose()	
do i3=1,n3
	do i2=1,n2 {
		call sreed( 'in', datr, 4*n1 )
		call convolve( ncoef, num, n1, datr, temp)
		call polydiv( ncoef, den, n1, temp, n1, datr)
		call srite('out', datr, 4*n1 )
	}
return
end

