program Syn
  use sep
  use helix
  use polydiv
  use triangle
  use random_mod

  implicit none
  integer, dimension (3)                :: is, i0
  integer                               :: n1, n2, static, jump, triwide, stat
  integer                               :: i1, i2, ip
  real,    dimension (:),   allocatable :: trace, tmp
  real,    dimension (:,:), allocatable :: yy 
  real,    dimension (3,2), target      :: bb
  real,    dimension (3)                :: amp, rho, freq
  type( filter)                         :: aa
  real                                  :: garbage, rand
  real,                     parameter   :: pi = 3.14159265

  call sep_init ()
  call from_par ("n1", n1, 24)
  call from_par ("n2", n2, 7)
  call to_history ("n3", 1)
  call to_history ("d2", 1.)
  call to_history ("esize", 4)

  call from_par ("jump",  jump, 2)
  call from_par ("static",  static, 2)
  call from_par ("triwide", triwide, 1)
  call from_par ("garbage", garbage, 0.)

  call from_par ('amp1',amp(1),1.)
  call from_par ('amp2',amp(2),1.)
  call from_par ('amp3',amp(3),0.)

  call from_par ('rho1',rho(1),0.)
  call from_par ('rho2',rho(2),0.)
  call from_par ('rho3',rho(3),0.)

  call from_par ('freq1',freq(1),0.)
  call from_par ('freq2',freq(2),0.)
  call from_par ('freq3',freq(3),0.)

  call from_par ('is1',is(1),1)
  call from_par ('is2',is(2),2)
  call from_par ('is3',is(3),1)

  i0 = (/ n1/3, n1/3+static, n1/2 /)

  allocate (yy (n1,n2), trace (n1), tmp (n1))
  yy = 0.

  do ip= 1, 3 
     bb (ip,:) = (/ - 2.*rho(ip)*cos (2.*pi*freq (ip)), rho(ip)*rho(ip) /)  
  end do

  call triangle_init (triwide,n1)
  allocate (aa%lag (2))
  do ip=1,3
     aa%flt => bb (ip,:)
     call polydiv_init (n1, aa) 
     do i2=1,n2 
        trace = 0.
        i1 = i0(ip) + jump * is(ip) * ( i2 - (n2+1)/2)
        if( 0 < i1 .and. i1 <= n1) trace( i1) = amp(ip)
        stat = polydiv_lop (.false.,.false.,trace,tmp)
        stat = triangle_lop (.true.,.false.,trace,tmp)
        yy(:,i2) = yy(:,i2) + trace
     end do
  end do
  deallocate (aa%lag)
  call triangle_close ()

  call random_init (1990)
  do i1=1,n1
     do i2=1,n2
        call random (rand, amp=2*garbage, pow=5)
        yy(i1,i2) = yy(i1,i2) + rand
     end do
  end do

  call sep_write (yy)
  deallocate (yy, trace, tmp)

  call exit (0)
end program Syn
