program make
  ! make n1=100 n2=14  > out.H
  !
  ! make generic synthetic data
  !%
  use sep
  use triangle
  use random_mod

  implicit none

  integer                            :: i1, i2, n1, n2, n, n3, p, t1, t2, stat
  real, dimension (:,:), allocatable :: pp
  real, dimension (:)  , allocatable :: s1, s2, m1, m2

  call sep_init ()
  call from_par ("n1", n1, 100)
  call from_par ("n2", n2,  14)

  call to_history ("n3"   , 1)
  call to_history ("esize", 4)

  allocate (pp(n1,n2))

  call from_par ("n", n, 3) ; n3=n1*n
  call from_par ("p", p, 3)

  allocate (s1 (n3), s2(n3), m1 (n3), m2 (n3))

  call random_init (1993)
  do i1 = 1, n3
     call random (s1 (i1), pow = p)
     call random (s2 (i1), pow = p)
  end do

  call from_par ("t1", t1, 4)
  call from_par ("t2", t2, 4)
  call sep_close ()

  call triangle_init (t1, n3)
  stat = triangle_lop (.true., .false., m1, s1)
  call triangle_close ()

  call triangle_init (t2, n3)
  stat = triangle_lop (.true., .false., m2, s2)
  call triangle_close ()

  deallocate (s1, s2)

  do i1=1, n1 
     do i2=1 ,n2 
        pp(i1,i2) =              m1( i1 + n/2 * n1 + i2  )
        pp(i1,i2) = pp(i1,i2) +  m2( i1 + n/2 * n1 - i2*2)
     end do
  end do

  call sep_write (pp) 

  deallocate (pp, m1, m2)
  call exit (0)
end program make
