program MSMiss
  use sep
  use mshelix
  use msmis2
  use bound

  implicit none
  integer                             :: na,ia, niter, is, ns, dim, nd
  real                                :: a0
  logical                             :: prec
  integer, dimension (:), allocatable :: n, m, a, jump
  real,    dimension (:), allocatable :: mm, kk
  logical, dimension (:), allocatable :: known
  type( msfilter)                     :: aa
  type( filter)                       :: bb

  call sep_init (SOURCE)
  dim = sep_dimension ()
  allocate (n( dim), m( dim), a(dim))
  call from_history (n)
  call from_par ("prec", prec, .true.)
  call from_par ("niter", niter, 100)
  call from_aux ("filt", na)
  call from_aux ("filt", "a", a)
  call from_aux ("filt","ns",ns)
  call msallocate (aa, na, ns)

  call from_aux ("filt","lag", aa%lag(:,1), (/ (ia, ia = 1, na) /))
  allocate (jump (ns))
  call from_aux ("filt","jump",jump)
  call from_aux ("filt","a0", a0, 1.)
  call from_aux ("filt","n",m)
  call sep_close ()

  nd = product (n)
  allocate (aa%mis (nd,ns))
  do is = 1, ns
     call onescale (is, aa, bb); nullify (bb%mis)
     bb%lag = aa%lag(:,1)*jump(is)/jump(1)
     call boundn (m, n, a*jump(is), bb)
     aa%mis (:,is) = bb%mis; deallocate (bb%mis)
  end do

  allocate (mm (nd), kk (nd), known (nd))
  call sep_read (mm)
  if (exist_file ("mask")) then
     call sep_read (kk, "mask")
     known = (kk /= 0.)
  else
     known = (mm /= 0.)
  end if

  call sep_read (aa%flt, "filt"); aa%flt = aa%flt/a0
  call mis1 (niter, nd, ns, mm, aa, known)
  call sep_write (mm)

  deallocate (n, m, jump, a, mm, kk, known)
  call msdeallocate( aa)
  call exit (0)
end program MSMiss
