program MSPF
  use sep
  use mshelix
  use createmshelixmod
  use mspef
  use misinput
  use print

  implicit none
  integer                             :: n123, is,ns, dim,i, niter
  integer, dimension (:), allocatable :: n, a, center, gap, jump
  real,    dimension (:),    pointer  :: dd, kk
  type( msfilter)                     :: msaa
  type( filter)                       :: aa

  call sep_init (SOURCE)
  dim = sep_dimension ()
  allocate (n (dim), a (dim), center (dim), gap (dim))
  call from_history (n); n123 = product (n)
  call to_history ("n",n)
  call from_par ("a", a)
  center=1; where (a (2:) > 1) center (:dim-1) = a (:dim-1)/2+1
  call from_par ("center", center, center)
  gap = 0
  call from_par ("gap", gap, gap)

  allocate (dd (n123), kk (n123))
  if (exist_file ("maskin")) then
     call sep_read (kk, "maskin")
  else
     kk = 1.
  end if
  call sep_read (dd)

  call from_par ("ns",ns)
  allocate (jump (ns))
  call from_par ("jump",jump)
  msaa = createmshelix( n, center, gap, jump, a)    ! allocate PEF
  call from_par( "niter", niter, size(msaa%lag, 1)*2 )

  do is = 1, ns 
     call onescale (is, msaa, aa)
     call find_mask( (kk /= 0.), aa)       ! missing data   
  end do
  if (exist_file ("maskout")) then
     do i=1, dim+1
        if (i <= dim) then
           call to_history (axisname(i),n(i),"maskout")
        else
           call to_history (axisname(i),ns,"maskout")
        end if
     end do
     call to_history ("esize",4,"maskout")
     do is = 1, ns
        where (msaa%mis (:,is)) 
           kk = 0.
        elsewhere
           kk = 1.
        end where
        call sep_write (kk, "maskout")
     end do
  end if

  call find_pef ( dd, msaa, niter)
  call onescale (1, msaa, aa)
  call printn( n, center*jump(1), a*jump(1), aa)
  call to_history ("n1", size(msaa%flt))
  call to_history ("n2", 1)
  call to_history ("n3", 1)
  call to_history ("lag", msaa%lag (:,1))
  call sep_write (msaa%flt)
  call sep_close ()
  deallocate (dd, kk)
  call msdeallocate (msaa)
  deallocate (n, center, gap, a, jump) 
  call exit (0)
end program MSPF



